package org.itscool.commons.file;

import java.io.File;
import java.util.Calendar;

/**
 * ONX̒ۃX[p[NXł
 * @author KANO
 * @since jdk1.4.1
 * @version 1.00A 2004/11/1
 */
public abstract class AbstractLog {
	 
	/** O F fobOp */
	public static final String DEBUG = "debug";
	/** O F CtH[Vp */
	public static final String INFO = "info";
	/** O F xp */
	public static final String WARN = "warn";
	/** O F G[Oo */
	public static final String ERROR = "error";
	/** O F G[Oo */
	public static final String SYSTEM = "system";
	/** Oo̓[hFR\[ */
	public static final String DISP_MODE = "disp";
	/** Oo̓[hFt@C */
	public static final String FILE_MODE = "file";
	/** Oo̓[hFR\[/t@C */
	public static final String ALLOUT_MODE = "all";

	/**
	 * t@C̍őTCYiKByte)
	*/
	protected int maxSize;  //KByte

	/**
	 * t@C܂߂pX
	*/
	protected String logPath;

	/**
	 * Ȍo̓x
	*/
	protected String level = DEBUG;
	protected int levelInt = 0;
	
	/**
	 * Ȍo̓[h
	*/
	protected String mode = DISP_MODE;
	
    /**
     * GR[fBO
     */
    protected String encode;
    
	/**
	 * Ox擾܂
	 * @return level
	 */
	public String getLevel() {
		return level;
	}
	/**
	 * OpX擾܂
	 * @return logPath
	 */
	public String getLogPath() {
		return logPath;
	}
	/**
	 * OMAXTCY擾܂
	 * @return maxSize
	 */
	public int getMaxSize() {
		return maxSize;
	}
	/**
	 * Ȍo̓[h擾܂
	 * @return mode
	 */
	public String getMode() {
		return mode;
	}
	
	public void debug(String msg){
		out(msg, DEBUG);
	}
    
	public void info(String msg){
		out(msg, INFO);
	}
	
	public void warn(String msg){
		out(msg, WARN);
	}
    
	public void error(String msg){
		out(msg, ERROR);
	}
    
	public void faital(String msg){
		out(msg, SYSTEM);
	}

	public abstract void out(String logMsg, String levelNow);
	
	/**
	 * Ox̎擾
	 * @param levelNow Ox
	 * @return Ox̖̂𕶎ŕԂ܂B
	*/
	public static String getLogKind( String levelNow){
		if( levelNow.equals(DEBUG)){
			return "DEBUG";
		}else if( levelNow.equals(INFO)){
			return "INFO ";
		}else if( levelNow.equals(WARN)){
			return "WORN ";
		}else if( levelNow.equals(ERROR)){
			return "ERROR";
		}else if( levelNow.equals(SYSTEM)){
            return "SYSTEM";
		}else{
			return "DEBUG";
		}
	}
    
    /**
     * Oo̓[h̎擾
     * @param mode Oo̓[h
     * @return Oo̓[ĥ̖𕶎ŕԂ܂B
    */
    public static String getLogMode( String mode){
        if( mode.equals(DISP_MODE)){
            return "DISP ONLY";
        }else if( mode.equals(FILE_MODE)){
            return "FILE ONLY";
        }else{
            return "DISP & FILE ";
        }
    }
    
	/**
	 * ݎ̎擾 
	 *
	 * @return yyyy/mm/dd/ hh:mimi:ss:msmsmsms `̎
	*/
	protected static String getNowDate(){
		//~bPʂŕ\B
		Calendar date = Calendar.getInstance();
		int year =date.get(Calendar.YEAR);
		int month = date.get(Calendar.MONTH) + 1;
		int day = date.get(Calendar.DATE);
		int hour = date.get(Calendar.HOUR);
		int minute = date.get(Calendar.MINUTE);
		int second = date.get(Calendar.SECOND);
        String monthPadding="";
        String dayPadding = "";
        String hourPadding = "";
        String minutePadding = "";
        String secondPadding = "";
        if( month < 10 ){
            monthPadding = "0";
        }
        if( day < 10 ){
            dayPadding = "0";
        }
        if( hour < 10 ){
            hourPadding = "0";
        }
        if( minute < 10 ){
            minutePadding = "0";
        }
        if( second < 10 ){
            secondPadding ="0";
        }
        //String mSecond = String.valueOf(date.get(Calendar.MILLISECOND ));
		StringBuffer ret = new StringBuffer();
        ret.append(year).append("/");
        ret.append(monthPadding).append(month).append("/");
        ret.append(dayPadding).append(day).append(" "); 
        ret.append(hourPadding).append(hour).append(":");
        ret.append(minutePadding).append(minute).append(":");
        ret.append(secondPadding).append(second );
        
        return ret.toString(); 
	}

	/**
	 * ݎ̎擾 
	 *
	 * @return yyyymmddHHMMSS `̎
	*/
	protected static String getNowDateYYYYMMDDHHMMSS(){
		//~bPʂŕ\B
		Calendar date = Calendar.getInstance() ;
		String year = String.valueOf(date.get(Calendar.YEAR));
		String month = String.valueOf(date.get(Calendar.MONTH));
		String day = String.valueOf(date.get(Calendar.DATE));
		String hour = String.valueOf(date.get(Calendar.HOUR));
		String minute = String.valueOf(date.get(Calendar.MINUTE));
		String second = String.valueOf(date.get(Calendar.SECOND ));
		return ( year + month + day + hour + minute + second ); 
	}

	/**
	 * Ot@C̃TCY`FbN Ot@C̑傫ȏ
	 * ł΃obNAbvt@CɒǉB
	 * obNAbvt@C̑傫ȏł΁AobNAbv
	 * 쐬B
	*/
	protected synchronized void sizeCheck(){
		File file = new File( logPath  );

		if( file.canRead() ){
			//maxSize𒴂ꍇ̓obNAbvt@CɎcB
			if( file.length() >= ( maxSize * 1024 ) ){
				file.renameTo( new File( logPath + "." + getNowDateYYYYMMDDHHMMSS() ));
			}
		}
		file = null;
	}
    /**
     * @return GR[hԂ܂
     */
    public String getEncode() {
        return encode;
    }
	public void setEncode(String encode) {
		this.encode = encode;
	}
	public void setLevel(String level) {
		this.level = level;
		levelInt = getLevelNum(level);
	}
	protected int getLevelNum(String level) {
		this.level = level;
		if( level.equals(DEBUG)){
			return 0;
		}else if( level.equals(INFO)){
			return 1;
		}else if( level.equals(WARN)){
			return 2;
		}else if( level.equals(ERROR)){
			return 3;
		}else if( level.equals(SYSTEM)){
			return 4;
		}else{
			return 0;
		}
	}
	public void setLogPath(String logPath) {
		this.logPath = logPath;
	}
	public void setMaxSize(int maxSize) {
		this.maxSize = maxSize;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}

}
